/*
 * @Author       : ChenJie
 * @Date         : 2022-02-10 11:43:56
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2022-02-23 15:51:23
 * @Description  : file content
 * @FilePath     : \S32K146_4G\src\AppTaskUart1.c
 */
/*
 * AppTaskUart2.c
 *  4GĴں
 *  Created on: 2022210
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskUart1.h"
const ATCmdFunc Atcmdfunc[] = {
	{AT_CMD_TEST, "AT\r\n", at_callbackFunc},
	{AT_SIMREADY, "AT+CPIN?\r\n", at_callbackFunc},
	{AT_GETICCID, "AT+CICCID\r\n", at_callbackFunc},
	{AT_CGREG, "AT+CGREG?\r\n", at_callbackFunc},
	{AT_CSQ, "AT+CSQ\r\n", at_callbackFunc},
	{AT_NETOPEN, "AT+NETOPEN\r\n", at_callbackFunc},
	{AT_CGIP, "AT+CDNSGIP=", at_callbackFunc},
	//{AT_CONNECT, "AT+CIPOPEN=0,\"TCP\",\"120.26.68.165\",14319\r\n", at_callbackFunc},
	{AT_CONNECT, "AT+CIPOPEN=", at_callbackFunc},
	{AT_CONNECTCHK, "AT+CIPOPEN?\r\n", at_callbackFunc},
	{AT_SEND, "AT+CIPSEND=", at_callbackFunc},
	{AT_DISCON, "AT+CIPCLOSE=0\r\n", at_callbackFunc},
	{AT_NETCLOSE, "AT+NETCLOSE\r\n", at_callbackFunc}};

static process_Tcp gProcess_Tcp_Task = PROCESS_TCP_IDLE;
#define PROC_TCP_STATE_SWITCH(a) (gProcess_Tcp_Task = a)
void InitFunc(void);
sint8 TcpConnectFunc(sint8 *ConnectId);
sint8 TcpDataSendFunc(sint8 ConnectId);
sint8 TcpRegisterChkFunc(void);
void TcpDataEncode(uint32 *PtrSendAddr, uint16 *SendLen);
void GetUtc8Time(UTC8TimeType *UTC8TimeTcp);
static void AtcmdTransmit(sint8 CmdIdx, uint8 *SetValuePtr, uint16 SetValueLen, sint8 *retFunc);
static void TcpDataInfoRecvHandle(uint8 *DataRecv,uint16 DataRecvLen);
void Uart_4G_Task(void *pvParameters)
{
	(void)pvParameters;
	// 4G
	Dio_WriteChannel(DioConf_DioChannel_PTA6_GPIO_OUT_MCU_4G_POW_EN, STD_ON);
	Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_ON);
	Dio_LevelType _4G_Status = 0; // 0-ػ1-
	_4G_Status = Dio_ReadChannel(DioConf_DioChannel_PTB1_GPIO_IN_MCU_4G_STATUS);
	// LED
	Dio_WriteChannel(DioConf_DioChannel_PTE0_GPIO_OUT_MCU_LED1, STD_OFF);
	vTaskDelay(pdMS_TO_TICKS(5000));
	uint8 pReadLen = 0;
	InitFunc(); // 4Gģʼ,עATͬͨûнджת
	uint32 SendTimerCounter = 0;
	for (;;)
	{
		switch (gProcess_Tcp_Task)
		{
		case PROCESS_TCP_IDLE: //״̬
		{
			vTaskDelay(pdMS_TO_TICKS(10));
			if (SocketId < 0)
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_REGCHK);
			}
			else if ((TimerCounter -SendTimerCounter)>1000 && AppConfigInfo.eolFlg==1)
			{
				SendTimerCounter = TimerCounter;
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_SEND);
				//Dio_FlipChannel(DioConf_DioChannel_PTE7_GPIO_OUT_MCU_LED3);
			}
			else if (TimerCounter % 100 == 0)
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_RECV);
			}
			break;
		}
		case PROCESS_TCP_ATSYS:
		{
			sint8 ATRet = -1;
			AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
			}
			else
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
			}
			break;
		}
		case PROCESS_TCP_REGCHK: //פ飬SIMCPIN,ICCIDȡ
		{
			RegChkRet = TcpRegisterChkFunc();
			if (RegChkRet > 0) //ͨSIMѾѽפ
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_CONNECT);
			}
			else
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
			}
			break;
		}
		case PROCESS_TCP_CONNECT: //ӣת
		{
			if (SocketId < 0)
			{
				sint8 ConnectRet = 0;
				ConnectRet = TcpConnectFunc(&SocketId);
				if (ConnectRet > 0)
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
				}
				else
				{
					PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
				}
			}
			break;
		}
		case PROCESS_TCP_SEND: //ݷ
		{
			sint8 SendRet = -1;
			SendRet = TcpDataSendFunc(SocketId);
			if (SendRet == 0)
			{
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
			}
			else
			{
				SocketId = -1;
				PROC_TCP_STATE_SWITCH(PROCESS_TCP_ERROR);
			}
			break;
		}
		case PROCESS_TCP_RECV: //ݽ,100ms״̬¼ɽ
		{
			memset(RX_Buffer[UART_LPUART1],0x00,sizeof(RX_Buffer[UART_LPUART1]));
			UART_Receive_Data(UART_LPUART1,RX_Buffer[UART_LPUART1],&pReadLen,100);
			if(pReadLen>0&&SocketId>=0)
			{
				TcpDataInfoRecvHandle(RX_Buffer[UART_LPUART1],pReadLen);
			}
			PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
			break;
		}
		case PROCESS_TCP_HEART: //
		{
			break;
		}
		case PROCESS_TCP_SLEEP: //״̬
		{
			break;
		}
		case PROCESS_TCP_ERROR: //״̬
		{
//			Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_OFF);
//			vTaskDelay(pdMS_TO_TICKS(100));
			PROC_TCP_STATE_SWITCH(PROCESS_TCP_IDLE);
//			Dio_WriteChannel(DioConf_DioChannel_PTA7_GPIO_OUT_MCU_4G_PWRKEY, STD_ON);
			break;
		}
		}
	}
}
sint8 TcpDataSendFunc(sint8 ConnectId)
{
	sint8 outValue = -1;
	uint32 pSendDataAddr = 0;
	uint16 DataSendLen = 0;
	memcpy(TcpbattSN, AppConfigInfo.deviceSn, 17);
	TcpDataEncode(&pSendDataAddr, &DataSendLen); //malloc,pSendDataָĵַ
	if (DataSendLen == 0)
	{
		return 0; //ʱݿԷ
	}
	outValue = tcpipConnectionSend(ConnectId,(uint8 *)pSendDataAddr,DataSendLen);//ͺ
	if (pSendDataAddr != 0)
	{
		free((uint8 *)(pSendDataAddr));
	}
	pSendDataAddr = 0;
	return outValue;
}
sint8 TcpConnectFunc(sint8 *ConnectId)
{
	uint8 ConnectStep = 0;
	sint8 ChkState = 0;
	sint8 ATRet = -1;
	while (1)
	{
		switch (ConnectStep)
		{
		case 0: // ATָͬ
		{
			char *ATCmdSend = (char *)("ATE0\r\n");
			uint8 ATCmdSendLen = mstrlen(ATCmdSend);
			uint8 ReadLen = 0;
			memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATCmdSend, ATCmdSendLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
			uint8 *retptr = NULL;
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("OK"));
				if (retptr)
				{
					ConnectStep++;
				}
				else
				{
					ChkState = -ConnectStep;
					return ChkState;
				}
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 1: // Netopen
		{
			AtcmdTransmit(AT_NETOPEN, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 2: //Ӽ
		{
			AtcmdTransmit(AT_CONNECTCHK, NULL, 0, &ATRet); // ATretصֵidδӷ-1
			if (ATRet >= 0)
			{
				*ConnectId = ATRet;
				return 1;
			}
			else
			{
				ConnectStep++;
			}
			break;
		}
		case 3: //ת
		{
			char AtCmdSend[30] = {0};
			uint8 AtCmdSendLen = 0;
			AtCmdSendLen = mstrlen(WebSiteName);
			memcpy(AtCmdSend, WebSiteName, AtCmdSendLen);
			memcpy(AtCmdSend + AtCmdSendLen, (char *)CRLF, sizeof(CRLF));
			AtCmdSendLen = AtCmdSendLen + 2;
			AtcmdTransmit(AT_CGIP, AtCmdSend, AtCmdSendLen, &ATRet);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				return ChkState;
			}
			break;
		}
		case 4: //
		{
			char AtCmdSend[20] = {0};
			uint8 AtCmdSendTotalLen = 0;
			*ConnectId = 0;
			sprintf(AtCmdSend, "%d,\"TCP\",%s,%d\r\n", *ConnectId, WebSiteIp, WebSitePort); //˴ҪŻ
			AtCmdSendTotalLen = mstrlen(AtCmdSend);
			AtcmdTransmit(AT_CONNECT, AtCmdSend, AtCmdSendTotalLen, &ATRet);
			if (ATRet == 0)
			{
				ConnectStep++;
			}
			else
			{
				ChkState = -ConnectStep;
				*ConnectId = -1;
				return ChkState;
			}
			break;
		}
		default:
			ChkState = ConnectStep;
			return ChkState;
		}
	}
}
sint8 TcpRegisterChkFunc(void)
{
	uint8 RegChkStep = 0;
	sint8 ChkState = 0; //ĬΪ0
	sint8 ATRet = -1;
	while (1)
	{
		switch (RegChkStep)
		{
		case 0: // ATָͬ
		{
			AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		case 1: // CPIN
		{
			AtcmdTransmit(AT_SIMREADY, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		case 2:
		{
			AtcmdTransmit(AT_CGREG, NULL, 0, &ATRet); //פ飬ֵ15פɹ
			if (ATRet == 1 || ATRet == 5)
			{
				RegChkStep++;
			}
			else
			{
				ChkState = -RegChkStep;
				return ChkState;
			}
			break;
		}
		default:
			ChkState = RegChkStep;
			return ChkState;
			break;
		}
	}
}
void InitFunc(void)
{
	// 4Gģʼ
	uint8 _4G_InitStep = 0;
	sint8 ATRet = -1;
	uint8 ReadLen = 0;
	char *ATCmdSend = NULL;
	uint8 ATCmdSendLen = 0;
	while (1)
	{
		switch (_4G_InitStep)
		{
		case 0: // ATָͬ
		{
			AtcmdTransmit(AT_CMD_TEST, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				_4G_InitStep++;
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 1: //رջ
		{
			ATCmdSend = (char *)("ATE0\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATCmdSend, ATCmdSendLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
			uint8 *retptr = NULL;
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("OK"));
				if (retptr)
				{
					_4G_InitStep++;
				}
				else
				{
					_4G_InitStep = 0;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 2: // IMEIȡ
		{
			ATCmdSend = (char *)("AT+SIMEI?\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATCmdSend, ATCmdSendLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
			uint8 *retptr = NULL;
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("+SIMEI"));
				if (retptr)
				{
					memcpy(ImeiNum, retptr + 8, 15);
					_4G_InitStep++;
				}
				else
				{
					_4G_InitStep = 0;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 3: // ʱԶ
		{
			ATCmdSend = (char *)("AT+CTZU=1\r\n");
			ATCmdSendLen = mstrlen(ATCmdSend);
			memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
			UART_Query_Data(UART_LPUART1, UART_LPUART1, ATCmdSend, ATCmdSendLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
			uint8 *retptr = NULL;
			if (ReadLen > 0)
			{
				retptr = (uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("OK"));
				if (retptr)
				{
					_4G_InitStep++;
				}
				else
				{
					_4G_InitStep = 0;
				}
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		case 4: // ICCIDȡ
		{
			AtcmdTransmit(AT_GETICCID, NULL, 0, &ATRet);
			if (ATRet == 0)
			{
				_4G_InitStep++;
			}
			else
			{
				_4G_InitStep = 0;
			}
			break;
		}
		default:
		{
			return;
			break;
		}
		}
	}
}
static void AtcmdTransmit(sint8 CmdIdx, uint8 *SetValuePtr, uint16 SetValueLen, sint8 *retFunc)
{
	uint16 ReadLen = 0;
	uint8 *PtrATCmdSend = NULL;
	uint8 ATCmdFixedLen = 0;
	uint16 ATCmdTotalLen = 0;
	ATCmdFixedLen = mstrlen(Atcmdfunc[CmdIdx].str);
	ATCmdTotalLen = ATCmdFixedLen + SetValueLen;
	PtrATCmdSend = malloc(ATCmdTotalLen + 1);
	memset(PtrATCmdSend, 0x00, ATCmdTotalLen + 1);
	memcpy(PtrATCmdSend, Atcmdfunc[CmdIdx].str, ATCmdFixedLen);
	if (SetValuePtr != NULL)
	{
		memcpy(PtrATCmdSend + ATCmdFixedLen, SetValuePtr, SetValueLen);
	}
	memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));

	UART_Query_Data(UART_LPUART1, UART_LPUART1, PtrATCmdSend, ATCmdTotalLen, RX_Buffer[UART_LPUART1], &ReadLen, 1000);

	*retFunc = Atcmdfunc[CmdIdx].cb(PtrATCmdSend, RX_Buffer[UART_LPUART1], CmdIdx, ReadLen);
	if (PtrATCmdSend != NULL)
	{
		memset(PtrATCmdSend, 0x00, ATCmdTotalLen + 1);
		free(PtrATCmdSend);
	}
	PtrATCmdSend = NULL;
	return;
}
sint8 at_callbackFunc(char *PSendStr, char *pReadStr, uint8 CmdIdx, uint16 pReadLen)
{
	sint8 OutValue = -1;
	uint8 *retptr = NULL;
	char *OkAns = "OK";
	retptr = (uint8 *)strstr((char *)pReadStr, OkAns);
	switch (CmdIdx)
	{
	case AT_CMD_TEST:
	{
		if (retptr)
		{
			OutValue = 0;
		}
		break;
	}
	case AT_SIMREADY:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("READY"));
			if (retptr)
			{
				OutValue = 0;
			}
		}
		break;
	}
	case AT_GETICCID:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("ICCID:"));
			if (retptr)
			{
				memcpy(IccidNum, retptr + 7, 20);
				OutValue = 0;
			}
		}
		break;
	}
	case AT_CGREG:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("CGREG:"));
			if (retptr)
			{
				uint8 RegN = 0;
				uint8 RegState = 0;
				RegN = CharToHex(*(retptr + 7));
				RegState = CharToHex(*(retptr + 9));
				OutValue = (RegState + RegN);
				return OutValue;
			}
		}

		break;
	}
	case AT_NETOPEN:
	{
		if (retptr)
		{
			OutValue = 0;
		}
		retptr = (uint8 *)strstr((char *)pReadStr, (char *)("opened")); //ظ
		if (retptr)
		{
			OutValue = 0;
		}
		break;
	}
	case AT_CONNECTCHK:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("TCP"));
			if (retptr)
			{
				OutValue = CharToHex(*(retptr - 3));
				return OutValue;
			}
		}
		break;
	}
	case AT_CGIP:
	{
		if (retptr)
		{
			for (uint8 i = 0; i < 30; i++)
			{
				if (*(retptr - i) == ',')
				{
					memcpy(WebSiteIp, retptr - i + 1, 15);
					OutValue = 0;
					break;
				}
			}
		}
		break;
	}
	case AT_CONNECT:
	{
		if (retptr)
		{
			retptr = (uint8 *)strstr((char *)pReadStr, (char *)("CIPOPEN:"));
			if (retptr)
			{
				SocketId = CharToHex(*(retptr + 9));
			}
			OutValue = 0;
		}
		break;
	}
	case AT_SEND:
	{
		retptr = (uint8 *)strstr((char *)pReadStr, (char *)(">"));
		if (retptr)
		{
			OutValue = 0;
		}
		break;
	}
	default:
		break;
	}
	return OutValue;
}
void TcpDataEncode(uint32 *PtrSendAddr, uint16 *SendLen)
{
	uint8 DataIdx = 0;
	static uint32 TcpSendTimeCounter = 0;
	TcpSendTimeCounter++;

	if (TcpSendTimeCounter == 1)
	{
		DataIdx = VerMsg; //汾Ϣ
	}
	else if (TcpSendTimeCounter % 10 == 0)
	{
		DataIdx = TruckBattMsg; //Ϣ
	}
	else if ((TcpSendTimeCounter - 1) % 60 == 0)
	{
		DataIdx = TruckVehiMsg; //Ϣ
	}
	else if ((TcpSendTimeCounter - 2) % 60 == 0)
	{
		DataIdx = TruckAcclMsg; //ۼϢ
	}
	else if (TcpSendTimeCounter % 60 == 0)
	{
		DataIdx = GpsMsg; //λϢ
	}
	else
	{
		*SendLen = 0;
		DataIdx = 0; //,
		return;
	}
	UTC8TimeType UTC8TimeTcp;
	GetUtc8Time(&UTC8TimeTcp); //ʱȡ
	uint8 *SendBuffer = NULL;
	switch (DataIdx)
	{
	case 0x82:
	{
		GPSInfo GpsRecvData;
		GPSMsgtoTcpType GpsToTcpInfo;
		*SendLen = sizeof(GpsToTcpInfo);
		SendBuffer = malloc(*SendLen);
		uint16 tac = 0;
		uint32 cellId = 0;
		uint8 DataLen = (uint16)sizeof(GpsToTcpInfo.gpsInfo);
		GpsToTcpInfo.startSymbol[0] = TCP_START_SYM1;
		GpsToTcpInfo.startSymbol[1] = TCP_START_SYM2;
		GpsToTcpInfo.cmdSymbol = TCP_CMD_SYM;
		GpsToTcpInfo.ansSymbol = TCP_ANS_SYM;
		memcpy(GpsToTcpInfo.SN, TcpbattSN, BATT_SN_LEN);
		GpsToTcpInfo.encryptMethod = TCP_ENCPT_DISABLE; // not encrypt
		GpsToTcpInfo.dataLength[0] = (DataLen >> 8) & 0xFF;
		GpsToTcpInfo.dataLength[1] = DataLen & 0xFF;
		GpsToTcpInfo.gpsInfo.sendTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		GpsToTcpInfo.gpsInfo.sendTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	 // month
		GpsToTcpInfo.gpsInfo.sendTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	 // day
		GpsToTcpInfo.gpsInfo.sendTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	 // hour
		GpsToTcpInfo.gpsInfo.sendTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		GpsToTcpInfo.gpsInfo.sendTimeUTC[5] = UTC8TimeTcp.second & 0xFF; // sec
		GpsToTcpInfo.gpsInfo.msgMark = DataIdx;
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[1] = UTC8TimeTcp.month & 0xFF;  // month
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	  // day
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	  // hour
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		GpsToTcpInfo.gpsInfo.msgCollectionTimeUTC[5] = UTC8TimeTcp.second & 0xFF;
		if (xQueueReceive(GpsDataQueueHandle, &GpsRecvData, 0) == pdPASS)
		{
			memcpy((uint8 *)&GpsToTcpInfo.gpsInfo.GpsInfoData, (uint8 *)&GpsRecvData, sizeof(GPSInfo));
		}
		else
		{
			memset((uint8 *)&GpsToTcpInfo.gpsInfo.GpsInfoData, 0x00, sizeof(GPSInfo));
		}
		GpsToTcpInfo.gpsInfo.Tac[0] = tac >> 8;
		GpsToTcpInfo.gpsInfo.Tac[1] = tac & 0xFF;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 24;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 16;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId >> 8;
		GpsToTcpInfo.gpsInfo.CellID[0] = cellId;
		uint16 xyzDatacahce[3] = {0};
		memcpy(xyzDatacahce, xyzData, 3);
		for (uint8 i = 0; i < 3; i++)
		{
			if (xyzDatacahce[i] > 0x8000) // Ϊ
			{
				xyzDatacahce[i] = (uint16)((uint16)(~(xyzDatacahce[i])) + 1);
				xyzDatacahce[i] = 20000U - xyzDatacahce[i];
			}
			else
			{
				xyzDatacahce[i] = xyzDatacahce[i] + 20000U;
			}
		}
		GpsToTcpInfo.gpsInfo.xData[0] = xyzDatacahce[0] >> 8;
		GpsToTcpInfo.gpsInfo.xData[1] = xyzDatacahce[0];
		GpsToTcpInfo.gpsInfo.yData[0] = xyzDatacahce[1] >> 8;
		GpsToTcpInfo.gpsInfo.yData[1] = xyzDatacahce[1];
		GpsToTcpInfo.gpsInfo.zData[0] = xyzDatacahce[2] >> 8;
		GpsToTcpInfo.gpsInfo.zData[1] = xyzDatacahce[2];
		GpsToTcpInfo.CRC = bcc_chk((uint8 *)&GpsToTcpInfo, sizeof(GPSMsgtoTcpType) - 1);
		memcpy(SendBuffer, &GpsToTcpInfo, sizeof(GpsToTcpInfo));
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x86:
	{
		VersionMsgtoTcpType VerMsgToTcpInfo;
		*SendLen = sizeof(VersionMsgtoTcpType);
		SendBuffer = malloc(*SendLen);
		uint16 DataLen = 0;
		DataLen = (uint16)sizeof(VerMsgToTcpInfo.VerInfo);
		VerMsgToTcpInfo.startSymbol[0] = TCP_START_SYM1;
		VerMsgToTcpInfo.startSymbol[1] = TCP_START_SYM2;
		VerMsgToTcpInfo.cmdSymbol = TCP_CMD_SYM;
		VerMsgToTcpInfo.ansSymbol = TCP_ANS_SYM;
		memcpy(VerMsgToTcpInfo.SN, TcpbattSN, BATT_SN_LEN);
		VerMsgToTcpInfo.encryptMethod = TCP_ENCPT_DISABLE; // not encrypt
		VerMsgToTcpInfo.dataLength[0] = (DataLen >> 8) & 0xFF;
		VerMsgToTcpInfo.dataLength[1] = DataLen & 0xFF;
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	// month
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	// day
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	// hour
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		VerMsgToTcpInfo.VerInfo.sendTimeUTC[5] = UTC8TimeTcp.second & 0xFF; // sec
		VerMsgToTcpInfo.VerInfo.msgMark = DataIdx;
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[0] = (UTC8TimeTcp.year) & 0xFF; // year
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[1] = UTC8TimeTcp.month & 0xFF;	 // month
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[2] = UTC8TimeTcp.day & 0xFF;	 // day
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[3] = UTC8TimeTcp.hour & 0xFF;	 // hour
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[4] = UTC8TimeTcp.minute & 0xFF; // mins
		VerMsgToTcpInfo.VerInfo.msgCollectionTimeUTC[5] = UTC8TimeTcp.second & 0xFF;
		memcpy(VerMsgToTcpInfo.VerInfo.ICCID, IccidNum, 20);
		memcpy(VerMsgToTcpInfo.VerInfo.IMEI, ImeiNum, 15);
		VerMsgToTcpInfo.VerInfo.BMSHwVersion[0] = bmsHwVersion>>8;
		VerMsgToTcpInfo.VerInfo.BMSHwVersion[1] = bmsHwVersion;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[0] = bmsSwVersion>>24;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[1] = bmsSwVersion>>16;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[2] = bmsSwVersion>>8;
		VerMsgToTcpInfo.VerInfo.BMSSwVersion[3] = bmsSwVersion;
		VerMsgToTcpInfo.VerInfo.HwVersion[0] = (HWVERSION >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.HwVersion[1] = (HWVERSION)&0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[0] = (BLSWVERSION >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[1] = (BLSWVERSION >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[2] = (BLSWVERSION >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.BLVersion[3] = (BLSWVERSION)&0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[0] = (DRVSWVERSION >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[1] = (DRVSWVERSION >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[2] = (DRVSWVERSION >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.DRVVersion[3] = (DRVSWVERSION)&0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[0] = (APPSWVERSION >> 24) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[1] = (APPSWVERSION >> 16) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[2] = (APPSWVERSION >> 8) & 0xFF;
		VerMsgToTcpInfo.VerInfo.APPVersion[3] = (APPSWVERSION)&0xFF;
		VerMsgToTcpInfo.VerInfo.BmsType = BMS_MANUFACTURE;
		VerMsgToTcpInfo.VerInfo.BmsInfo = BMS_INFO;
		VerMsgToTcpInfo.VerInfo.DataModuleType = DATA_MODULE_TYPE;
		VerMsgToTcpInfo.CRC = bcc_chk((uint8 *)&VerMsgToTcpInfo, sizeof(VerMsgToTcpInfo) - 1);
		memcpy(SendBuffer, &VerMsgToTcpInfo, sizeof(VersionMsgtoTcpType));
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x90:
	{
		*SendLen = 0x52;
		SendBuffer = malloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x39;							   // 57
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF);	   // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF); // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);	// uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);	// uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);	// uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF); // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF); // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);			// uint8	BATTMSG
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF); // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);	// uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);	// uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);	// uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF); // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF); // uint8	second
		memcpy(SendBuffer + 0x25, VIN, 17);
		*(SendBuffer + 0x36) = (vehicleStatus & 0xFF);		 // uint8	״̬
		*(SendBuffer + 0x37) = (bmsHVOn & 0xFF);			 // uint8	bmsϸѹָ
		*(SendBuffer + 0x38) = (currentGearPosition & 0xFF); // uint8	ǰλ
		*(SendBuffer + 0x39) = (parkingBreakStatus & 0xFF);	 // uint8	ɲź
		*(SendBuffer + 0x3A) = (breakingStatus & 0xFF);		 // uint8	ƶ
		*(SendBuffer + 0x3B) = ((ODO >> 24) & 0xFF);		 // uint32	
		*(SendBuffer + 0x3C) = ((ODO >> 16) & 0xFF);
		*(SendBuffer + 0x3D) = ((ODO >> 8) & 0xFF);
		*(SendBuffer + 0x3E) = (ODO & 0xFF);
		*(SendBuffer + 0x3F) = (dcdcWorkStatus & 0xFF);			// uint8 DCDC״̬
		*(SendBuffer + 0x40) = (numOfChrgableSubsys & 0xFF);	// uint8	ɳϵͳ
		*(SendBuffer + 0x41) = (chrgableSubsysCode & 0xFF);		// uint8	ɳ索ϵͳ
		*(SendBuffer + 0x42) = (BMS8_MaxTempSysNr & 0xFF);		// uint8	¶ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x43) = (BMS8_MaxTempNr & 0xFF);			// uint8	¶̽뵥 _1ƫ_0λ_
		*(SendBuffer + 0x44) = (BMS8_MinTempSysNr & 0xFF);		// uint8	¶ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x45) = (BMS8_MinTempNr & 0xFF);			// uint8	¶̽ϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x46) = (BMS7_MaxUcellSysNr & 0xFF);		// uint8	ߵѹϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x47) = ((BMS7_MaxUcellNr >> 8) & 0xFF); // uint16	ߵѹص _1ƫ_0λ_
		*(SendBuffer + 0x48) = (BMS7_MaxUcellNr & 0xFF);
		*(SendBuffer + 0x49) = (BMS7_MinUcellSysNr & 0xFF);		// uint8	͵ѹϵͳ _1ƫ_0λ_
		*(SendBuffer + 0x4A) = ((BMS7_MinUcellNr >> 8) & 0xFF); // uint16	͵ѹص _1ƫ_0λ_
		*(SendBuffer + 0x4B) = (BMS7_MinUcellNr & 0xFF);
		*(SendBuffer + 0x4C) = (ebcStatus & 0xFF); // uint8 ״̬
		*(SendBuffer + 0x4D) = (uint8)((ebcAskHVOn & 0x01) | ((ebcAskHVOff & 0x01) << 1) | ((retainLockSignal & 0x01) << 3) | ((dischargeLockSignal & 0x01) << 5) | ((chargeLockSignal & 0x01) << 6));
		*(SendBuffer + 0x4E) = (chargeFlag & 0xFF);		 // uint8 ־λ
		*(SendBuffer + 0x4F) = ((vcuDCVol >> 8) & 0xFF); // uint16 ֱĸߵѹ
		*(SendBuffer + 0x50) = (vcuDCVol & 0xFF);
		*(SendBuffer + 0x51) = bcc_chk(SendBuffer, 0x51);
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x91:
	{
		*SendLen = 0x54 + 384 * 2 + 64;
		SendBuffer = malloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x3B + 384 * 2 + 64;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF);		  // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);		  // uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);		  // uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);		  // uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);		  // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);		  // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);				  // uint8	BATTMSG
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF);		  // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);		  // uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);		  // uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);		  // uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);		  // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);		  // uint8	second
		*(SendBuffer + 0x25) = (CSQValue & 0xFF);				  // uint8	csq
		*(SendBuffer + 0x26) = (BMS1_SysSts & 0xFF);			  // uint8	عϵͳ״̬0-ʼ 1-Լϵ 2-״̬ 3-ѹж 4-״̬_1ƫ_0λ_
		*(SendBuffer + 0x27) = (BMS1_DCChrgConnectSt & 0xFF);	  // uint8	ֱǹ״̬0-δ 1-ǹ 2-˫ǹ 3-Ч_1ƫ_0λ_
		*(SendBuffer + 0x28) = (BMS2_FaultLevel & 0xFF);		  // uint8	ǰ߹ϵȼ0- 1-1 ΢ 2-2 ع 3-3 عϣ_1ƫ_0λ_
		*(SendBuffer + 0x29) = (BMS2_FaultCode & 0xFF);			  // uint8	룬BMS_ErrCode_1ƫ_0λ_
		*(SendBuffer + 0x2A) = (BMS2_RqHVPoerOff & 0xFF);		  // uint8	BMS¸ѹ0-Ч 1-¸ѹ 2-¸ѹ 3-Ч_1ƫ_0λ_
		*(SendBuffer + 0x2B) = (BMS1_ChrgStatus & 0xFF);		  // uint8	״̬0-δ 1- 2- 3-ϣ_1ƫ_0λ_
		*(SendBuffer + 0x2C) = (BMS2_SOC & 0xFF);				  // uint8	ذSOC _0.4ƫ_0λ_*(SendBuffer+0x2D)	=	(BMS2_SOH&0xFF);		//uint8	ذSOH _0.4ƫ_0λ_*(SendBuffer+0x2E)	=	((BMS2_PackInsideVolt>>8)&0xFF);		//uint16	ذڲѹ _0.1ƫ_0λ_V
		*(SendBuffer + 0x2D) = (BMS2_SOH / 25 * 10) & 0xFF;		  // SOH 1%
		*(SendBuffer + 0x2E) = (BMS2_PackInsideVolt >> 8) & 0xFF; //ذܵѹ
		*(SendBuffer + 0x2F) = (BMS2_PackInsideVolt & 0xFF);
		*(SendBuffer + 0x30) = ((BMS2_PackCurrent >> 8) & 0xFF); // uint16	ذܵΪֵŵΪֵ _0.1ƫ_-1000λ_A
		*(SendBuffer + 0x31) = (BMS2_PackCurrent & 0xFF);
		*(SendBuffer + 0x32) = ((BMS4_SysInsRes >> 8) & 0xFF); // uint16	ϵͳԵ _1ƫ_0λ_K
		*(SendBuffer + 0x33) = (BMS4_SysInsRes & 0xFF);
		*(SendBuffer + 0x34) = (BMS1_MainPosRelaySt & 0xFF);	// uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x35) = (BMS1_PreChgRelaySt & 0xFF);		// uint8	Ԥ̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x36) = (BMS1_MainNegRelaySt & 0xFF);	// uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x37) = (BMS1_DCChrgPos1RelaySt & 0xFF); // uint8	̵ֱ1״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x38) = (BMS1_DCChrgNeg1RelaySt & 0xFF); // uint8	ֱ为̵1״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x39) = (BMS1_DCChrgPos2RelaySt & 0xFF); // uint8	̵ֱ2״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3A) = (BMS1_DCChrgNeg2RelaySt & 0xFF); // uint8	ֱ为̵2״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3B) = (BMS1_HeatPosRelaySt & 0xFF);	// uint8	̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_
		*(SendBuffer + 0x3C) = (BMS1_HeatNegRelaySt & 0xFF);	// uint8	ȸ̵״̬0-Ԥ 1-Ͽ 2-  _1ƫ_0λ_

		*(SendBuffer + 0x50) = ((BMS9_PackTotCellNum >> 8) & 0xFF); // uint16	PACKеоĿ
		*(SendBuffer + 0x51) = (BMS9_PackTotCellNum & 0xFF);
		for (uint16 index = 0; index < BMS9_PackTotCellNum; index++)
		{
			*(SendBuffer + 0x52 + index * 2) = ((BMS_Cell_Volt[index] >> 8) & 0xFF);
			*(SendBuffer + 0x52 + index * 2 + 1) = ((BMS_Cell_Volt[index]) & 0xFF);
		}
		*(SendBuffer + 0x352) = (BMS9_PackTotTempNum & 0xFF); //  uint8	PACKео¶ȵ(̽)Ŀ
		memcpy(SendBuffer + 0x353, BMS_Cell_TempN, BMS9_PackTotTempNum);
		*(SendBuffer + 0x393) = bcc_chk(SendBuffer, 0x393);
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	case 0x92:
	{
		*SendLen = 0x4E;
		SendBuffer = malloc(*SendLen);
		*(SendBuffer + 0) = TCP_START_SYM1;
		*(SendBuffer + 1) = TCP_START_SYM2;
		*(SendBuffer + 2) = TCP_CMD_SYM;
		*(SendBuffer + 3) = TCP_ANS_SYM;
		memcpy(SendBuffer + 4, TcpbattSN, BATT_SN_LEN);
		*(SendBuffer + 0x15) = (TCP_ENCPT_DISABLE & 0xFF); // uint8	TCP_ENCPT_DISABLE
		uint16 DataLen = 0x35;
		*(SendBuffer + 0x16) = ((DataLen >> 8) & 0xFF); // uint16	DataLen
		*(SendBuffer + 0x17) = (DataLen & 0xFF);
		*(SendBuffer + 0x18) = ((UTC8TimeTcp.year) & 0xFF);			 // uint8	year
		*(SendBuffer + 0x19) = (UTC8TimeTcp.month & 0xFF);			 // uint8	month
		*(SendBuffer + 0x1A) = (UTC8TimeTcp.day & 0xFF);			 // uint8	day
		*(SendBuffer + 0x1B) = (UTC8TimeTcp.hour & 0xFF);			 // uint8	hour
		*(SendBuffer + 0x1C) = (UTC8TimeTcp.minute & 0xFF);			 // uint8	minute
		*(SendBuffer + 0x1D) = (UTC8TimeTcp.second & 0xFF);			 // uint8	second
		*(SendBuffer + 0x1E) = (DataIdx & 0xFF);					 // uint8
		*(SendBuffer + 0x1F) = ((UTC8TimeTcp.year) & 0xFF);			 // uint8	year
		*(SendBuffer + 0x20) = (UTC8TimeTcp.month & 0xFF);			 // uint8	month
		*(SendBuffer + 0x21) = (UTC8TimeTcp.day & 0xFF);			 // uint8	day
		*(SendBuffer + 0x22) = (UTC8TimeTcp.hour & 0xFF);			 // uint8	hour
		*(SendBuffer + 0x23) = (UTC8TimeTcp.minute & 0xFF);			 // uint8	minute
		*(SendBuffer + 0x24) = (UTC8TimeTcp.second & 0xFF);			 // uint8	second
		*(SendBuffer + 0x25) = ((BMS14_TotalChargeAh >> 24) & 0xFF); // uint32	ۻAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x26) = ((BMS14_TotalChargeAh >> 16) & 0xFF);
		*(SendBuffer + 0x27) = ((BMS14_TotalChargeAh >> 8) & 0xFF);
		*(SendBuffer + 0x28) = (BMS14_TotalChargeAh & 0xFF);
		*(SendBuffer + 0x29) = ((BMS14_TotalDischargeAh >> 24) & 0xFF); // uint32	ۻųAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x2A) = ((BMS14_TotalDischargeAh >> 16) & 0xFF);
		*(SendBuffer + 0x2B) = ((BMS14_TotalDischargeAh >> 8) & 0xFF);
		*(SendBuffer + 0x2C) = (BMS14_TotalDischargeAh & 0xFF);
		*(SendBuffer + 0x2D) = ((BMS15_TotalChargeKwh >> 24) & 0xFF); // uint32	ۼƳkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x2E) = ((BMS15_TotalChargeKwh >> 16) & 0xFF);
		*(SendBuffer + 0x2F) = ((BMS15_TotalChargeKwh >> 8) & 0xFF);
		*(SendBuffer + 0x30) = (BMS15_TotalChargeKwh & 0xFF);
		*(SendBuffer + 0x31) = ((BMS15_TotalDischargeKwh >> 24) & 0xFF); // uint32	ۼƷųkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x32) = ((BMS15_TotalDischargeKwh >> 16) & 0xFF);
		*(SendBuffer + 0x33) = ((BMS15_TotalDischargeKwh >> 8) & 0xFF);
		*(SendBuffer + 0x34) = (BMS15_TotalDischargeKwh & 0xFF);
		*(SendBuffer + 0x35) = ((BMS16_TotalEneryECOChargeAh >> 24) & 0xFF); // uint32	ۼƶܻAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x36) = ((BMS16_TotalEneryECOChargeAh >> 16) & 0xFF);
		*(SendBuffer + 0x37) = ((BMS16_TotalEneryECOChargeAh >> 8) & 0xFF);
		*(SendBuffer + 0x38) = (BMS16_TotalEneryECOChargeAh & 0xFF);
		*(SendBuffer + 0x39) = ((BMS16_TotalEneryECOChargeKwh >> 24) & 0xFF); // uint32	ۼƶܻkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x3A) = ((BMS16_TotalEneryECOChargeKwh >> 16) & 0xFF);
		*(SendBuffer + 0x3B) = ((BMS16_TotalEneryECOChargeKwh >> 8) & 0xFF);
		*(SendBuffer + 0x3C) = (BMS16_TotalEneryECOChargeKwh & 0xFF);
		*(SendBuffer + 0x3D) = ((BMS17_TotalStationChargeAh >> 24) & 0xFF); // uint32	ۼƻվAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x3E) = ((BMS17_TotalStationChargeAh >> 16) & 0xFF);
		*(SendBuffer + 0x3F) = ((BMS17_TotalStationChargeAh >> 8) & 0xFF);
		*(SendBuffer + 0x40) = (BMS17_TotalStationChargeAh & 0xFF);
		*(SendBuffer + 0x41) = ((BMS17_TotalStationChargeKwh >> 24) & 0xFF); // uint32	ۼƻվkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x42) = ((BMS17_TotalStationChargeKwh >> 16) & 0xFF);
		*(SendBuffer + 0x43) = ((BMS17_TotalStationChargeKwh >> 8) & 0xFF);
		*(SendBuffer + 0x44) = (BMS17_TotalStationChargeKwh & 0xFF);
		*(SendBuffer + 0x45) = ((BMS18_TotalPoleChargeAh >> 24) & 0xFF); // uint32	ۼƲǹAh  _0.1ƫ_0λ_Ah
		*(SendBuffer + 0x46) = ((BMS18_TotalPoleChargeAh >> 16) & 0xFF);
		*(SendBuffer + 0x47) = ((BMS18_TotalPoleChargeAh >> 8) & 0xFF);
		*(SendBuffer + 0x48) = (BMS18_TotalPoleChargeAh & 0xFF);
		*(SendBuffer + 0x49) = ((BMS18_TotalPoleChargeKwh >> 24) & 0xFF); // uint32	ۼƲǹkWh  _0.1ƫ_0λ_KWh
		*(SendBuffer + 0x4A) = ((BMS18_TotalPoleChargeKwh >> 16) & 0xFF);
		*(SendBuffer + 0x4B) = ((BMS18_TotalPoleChargeKwh >> 8) & 0xFF);
		*(SendBuffer + 0x4C) = (BMS18_TotalPoleChargeKwh & 0xFF);
		*(SendBuffer + 0x4D) = bcc_chk(SendBuffer, 0x4D);
		*PtrSendAddr = (uint32)SendBuffer;
		break;
	}
	default:
		break;
	}
}
void GetUtc8Time(UTC8TimeType *UTC8TimeTcp)
{
	char *AtCmdAsk = (char *)("AT+CCLK?\r\n");
	uint8 AtCmdLen = mstrlen(AtCmdAsk);
	uint8 ReadLen = 0;
	uint8 *retptr = NULL;
	memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
	UART_Query_Data(UART_LPUART1, UART_LPUART1, AtCmdAsk, AtCmdLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
	if (ReadLen > 0)
	{
		if ((uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("OK")))
		{
			retptr = (uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("+CCLK:"));
			UTC8TimeTcp->year = CharToHex(*(retptr + 8)) * 10 + CharToHex(*(retptr + 9));
			UTC8TimeTcp->month = CharToHex(*(retptr + 11)) * 10 + CharToHex(*(retptr + 12));
			UTC8TimeTcp->day = CharToHex(*(retptr + 14)) * 10 + CharToHex(*(retptr + 15));
			UTC8TimeTcp->hour = CharToHex(*(retptr + 17)) * 10 + CharToHex(*(retptr + 18));
			UTC8TimeTcp->minute = CharToHex(*(retptr + 20)) * 10 + CharToHex(*(retptr + 21));
			UTC8TimeTcp->second = CharToHex(*(retptr + 23)) * 10 + CharToHex(*(retptr + 24));
		}
	}
}
static void TcpDataInfoRecvHandle(uint8 *DataRecv,uint16 DataRecvLen)
{
    uint8 Tcp_Cmd;
    uint8 *Ptr=NULL,*retptr=NULL;
    uint8 TcpCmdAnswer[31];
    uint16 TcpDataLen = 0;
    uint16 NumCalTemp = 1;
    retptr = (uint8 *)strstr((char *)DataRecv, (char *)("\r\n##"));
    if(retptr==NULL)return;
    for(uint8 i=0;i<5;i++)
    {
    	if(*(retptr - i - 1)=='D')
		{
			break;
		}
    	TcpDataLen = TcpDataLen + CharToHex(*(retptr - i - 1))*NumCalTemp;
    	NumCalTemp = NumCalTemp*10;
    }
    if (TcpDataLen>0)
    {
        Ptr = retptr + 2;
        if ((*(Ptr + 0) == TCP_START_SYM1) && (*(Ptr + 1) == TCP_START_SYM2)) //ʼϢ
        {
            Tcp_Cmd = *(Ptr + 2); //־
            if (*(Ptr + 3) == 0xFE)
            {
//                TCPWorkState = 0x01;//ҪͣͣӦı־
            }
            switch (Tcp_Cmd)
            {
            case TCP_QUERY_SYM:
                break;
            case TCP_SETCMD_SYM:
                break;
            case TCP_CONCMD_SYM:
            {
                TcpCmdAnswer[0] = TCP_START_SYM1;
                TcpCmdAnswer[1] = TCP_START_SYM1;
                TcpCmdAnswer[2] = TCP_CONCMD_SYM;
                if (*(Ptr + 30) == 0x01)//Զָ
                {

                }
                else
                {
                    TcpCmdAnswer[3] = 0x0f;
                    memcpy(&TcpCmdAnswer[4], (Ptr + 4), BATT_SN_LEN);
                    TcpCmdAnswer[21] = TCP_ENCPT_DISABLE;
                    TcpCmdAnswer[22] = 0x00;
                    TcpCmdAnswer[23] = 0x06;
                    memcpy(&TcpCmdAnswer[24], (Ptr + 24), 6);
                    TcpCmdAnswer[30] = bcc_chk(TcpCmdAnswer, 30);
                    tcpipConnectionSend(SocketId, TcpCmdAnswer, 31);
                }
            }
            default:
            {
                break;
            }
            }
        }
    }
}
sint8 tcpipConnectionSend(uint8 TcpConnectId,uint8 * SendDataPtr,uint16 SendDataLen)
{
	sint8 outValue = -1;
	sint8 ATRet = -1;
	uint8 ReadLen = 0;
	char AtCmdSend[10] = {0};
	uint8 AtCmdSendTotalLen = 0;
	sprintf(AtCmdSend, "%d,%d\r\n", TcpConnectId, SendDataLen);
	AtCmdSendTotalLen = mstrlen(AtCmdSend);
	AtcmdTransmit(AT_SEND, AtCmdSend, AtCmdSendTotalLen, &ATRet);
	if (ATRet == 0)
	{
		memset(RX_Buffer[UART_LPUART1], 0x00, sizeof(RX_Buffer[UART_LPUART1]));
		UART_Query_Data(UART_LPUART1, UART_LPUART1, (uint8 *)SendDataPtr, SendDataLen, RX_Buffer[UART_LPUART1], &ReadLen, 100);
		if ((uint8 *)strstr((char *)RX_Buffer[UART_LPUART1], (char *)("OK")))
		{
			outValue = 0;
		}
	}
	return outValue;
}
